//-----------------------------------------------------
// name: "Saxophone"
// author: "Romain Michon"
// copyright: "Romain Michon (rmichon@ccrma.stanford.edu)"
// version: "1.0"
//
// Code generated with Faust 0.9.55 (http://faust.grame.fr)
//-----------------------------------------------------
/* link with  */
#include <math.h>
#include <cmath>
template <int N> inline float faustpower(float x) 		{ return powf(x,N); } 
template <int N> inline double faustpower(double x) 	{ return pow(x,N); }
template <int N> inline int faustpower(int x) 			{ return faustpower<N/2>(x) * faustpower<N-N/2>(x); } 
template <> 	 inline int faustpower<0>(int x) 		{ return 1; }
template <> 	 inline int faustpower<1>(int x) 		{ return x; }
#include <math.h>
#include <string>

/*
#include "/usr/share/faust/audio/dsp.h"
#include "/usr/share/faust/gui/UI.h"
*/

#include "/home/kjetil/faudiostream/architecture/faust/audio/dsp.h"
#include "/home/kjetil/faudiostream/architecture/faust/gui/UI.h"

struct Meta
{
    void declare (const char* key, const char* value) { }
};

static float scale(float x, float x1, float x2, float y1, float y2){
  return y1 + ( ((x-x1)*(y2-y1))
                /
                (x2-x1)
                );
}

#if 0
static float linear2db(float val){
  if(val<=0.0f)
    return 0.0f;

  float db = 20*log10(val);
  if(db<-70)
    return 0.0f;
  else if(db>40)
    return 1.0f;
  else
    return scale(db,-70,40,0,1);
}
#endif

// input is between 0 and 1.
// output is between 0 and 1.
static float velocity2gain(float val){
  if(val<=0.0f)
    return 0.0f;
  else if(val>=1.0f)
    return 1.0f;
  else
    return powf(10, scale(val,0.0, 1.0 ,-40, 20) / 20.0f) / 10.0f;
}


static double midi_to_hz(float midi){
  if(midi<=0)
    return 0;
  else
    //  return 1;
  return 8.17579891564*(expf(.0577622650*midi));
}

#if 0
// For some reason, it won't compile with the usual min/max macros.
template<typename T> static inline T min(T a,T b){return a<b ? a : b;}
template<typename T> static inline T max(T a,T b){return a>b ? a : b;}
static inline float min(float a,int b){return a<b ? a : b;}
static inline float max(float a,int b){return a>b ? a : b;}
static inline float min(int a,float b){return a<b ? a : b;}
static inline float max(int a,float b){return a>b ? a : b;}
#endif

inline int 	max (unsigned int a, unsigned int b) { return (a>b) ? a : b; }
inline int 	max (int a, int b)		{ return (a>b) ? a : b; }

inline long 	max (long a, long b) 		{ return (a>b) ? a : b; }
inline long 	max (int a, long b) 		{ return (a>b) ? a : b; }
inline long 	max (long a, int b) 		{ return (a>b) ? a : b; }

inline float 	max (float a, float b) 		{ return (a>b) ? a : b; }
inline float 	max (int a, float b) 		{ return (a>b) ? a : b; }
inline float 	max (float a, int b) 		{ return (a>b) ? a : b; }
inline float 	max (long a, float b) 		{ return (a>b) ? a : b; }
inline float 	max (float a, long b) 		{ return (a>b) ? a : b; }

inline double 	max (double a, double b) 	{ return (a>b) ? a : b; }
inline double 	max (int a, double b) 		{ return (a>b) ? a : b; }
inline double 	max (double a, int b) 		{ return (a>b) ? a : b; }
inline double 	max (long a, double b) 		{ return (a>b) ? a : b; }
inline double 	max (double a, long b) 		{ return (a>b) ? a : b; }
inline double 	max (float a, double b) 	{ return (a>b) ? a : b; }
inline double 	max (double a, float b) 	{ return (a>b) ? a : b; }


inline int	min (int a, int b)		{ return (a<b) ? a : b; }

inline long 	min (long a, long b) 		{ return (a<b) ? a : b; }
inline long 	min (int a, long b) 		{ return (a<b) ? a : b; }
inline long 	min (long a, int b) 		{ return (a<b) ? a : b; }

inline float 	min (float a, float b) 		{ return (a<b) ? a : b; }
inline float 	min (int a, float b) 		{ return (a<b) ? a : b; }
inline float 	min (float a, int b) 		{ return (a<b) ? a : b; }
inline float 	min (long a, float b) 		{ return (a<b) ? a : b; }
inline float 	min (float a, long b) 		{ return (a<b) ? a : b; }

inline double 	min (double a, double b) 	{ return (a<b) ? a : b; }
inline double 	min (int a, double b) 		{ return (a<b) ? a : b; }
inline double 	min (double a, int b) 		{ return (a<b) ? a : b; }
inline double 	min (long a, double b) 		{ return (a<b) ? a : b; }
inline double 	min (double a, long b) 		{ return (a<b) ? a : b; }
inline double 	min (float a, double b) 	{ return (a<b) ? a : b; }
inline double 	min (double a, float b) 	{ return (a<b) ? a : b; }


/******************************************************************************
*******************************************************************************

							       VECTOR INTRINSICS

*******************************************************************************
*******************************************************************************/


/******************************************************************************
*******************************************************************************

			ABSTRACT USER INTERFACE

*******************************************************************************
*******************************************************************************/

//----------------------------------------------------------------------------
//  FAUST generated signal processor
//----------------------------------------------------------------------------

#ifndef FAUSTFLOAT
#define FAUSTFLOAT float
#endif  

typedef long double quad;

#ifndef FAUSTCLASS 
#define FAUSTCLASS Saxophony_dsp
#endif

class Saxophony_dsp : public dsp {
  private:
	class SIG0 {
	  private:
		int 	fSamplingFreq;
		int 	iRec2[2];
	  public:
		int getNumInputs() 	{ return 0; }
		int getNumOutputs() 	{ return 1; }
		void init(int samplingFreq) {
			fSamplingFreq = samplingFreq;
			for (int i=0; i<2; i++) iRec2[i] = 0;
		}
		void fill (int count, float output[]) {
			for (int i=0; i<count; i++) {
				iRec2[0] = (1 + iRec2[1]);
				output[i] = sinf((9.587379924285257e-05f * float((iRec2[0] - 1))));
				// post processing
				iRec2[1] = iRec2[0];
			}
		}
	};


	static float 	ftbl0[65536];
	FAUSTFLOAT 	fslider0;
	float 	fRec4[2];
	FAUSTFLOAT 	fentry0;
	FAUSTFLOAT 	fentry1;
	int 	iConst0;
	float 	fConst1;
	float 	fRec3[2];
	FAUSTFLOAT 	fbutton0;
	float 	fRec7[2];
	int 	iRec5[2];
	FAUSTFLOAT 	fslider1;
	FAUSTFLOAT 	fslider2;
	float 	fRec6[2];
	FAUSTFLOAT 	fslider3;
	float 	fRec8[2];
	FAUSTFLOAT 	fslider4;
	float 	fVec0[2];
	float 	fRec14[2];
	float 	fRec13[2];
	float 	fRec12[2];
	float 	fRec11[2];
	float 	fRec10[2];
	float 	fRec9[2];
	float 	fRec20[2];
	float 	fRec19[2];
	float 	fRec18[2];
	float 	fRec17[2];
	float 	fRec16[2];
	float 	fRec15[2];
	float 	fVec1[2];
	int 	IOTA;
	float 	fVec2[4096];
	FAUSTFLOAT 	fslider5;
	float 	fRec21[2];
	FAUSTFLOAT 	fslider6;
	int 	iRec22[2];
	FAUSTFLOAT 	fslider7;
	int 	iRec23[2];
	FAUSTFLOAT 	fslider8;
	FAUSTFLOAT 	fslider9;
	float 	fRec24[2];
	FAUSTFLOAT 	fslider10;
	float 	fRec0[8192];
	FAUSTFLOAT 	fslider11;
	FAUSTFLOAT 	fentry2;
	float 	fVec3[4096];
	FAUSTFLOAT 	fslider12;
	float 	fConst2;
  public:
	static void metadata(Meta* m) 	{ 
		m->declare("name", "Saxophone");
		m->declare("description", "Nonlinear WaveGuide Saxophone");
		m->declare("author", "Romain Michon");
		m->declare("copyright", "Romain Michon (rmichon@ccrma.stanford.edu)");
		m->declare("version", "1.0");
		m->declare("licence", "STK-4.3");
		m->declare("reference", "https://ccrma.stanford.edu/~jos/pasp/Woodwinds.html");
		m->declare("music.lib/name", "Music Library");
		m->declare("music.lib/author", "GRAME");
		m->declare("music.lib/copyright", "GRAME");
		m->declare("music.lib/version", "1.0");
		m->declare("music.lib/license", "LGPL with exception");
		m->declare("math.lib/name", "Math Library");
		m->declare("math.lib/author", "GRAME");
		m->declare("math.lib/copyright", "GRAME");
		m->declare("math.lib/version", "1.0");
		m->declare("math.lib/license", "LGPL with exception");
		m->declare("instrument.lib/name", "Faust-STK Tools Library");
		m->declare("instrument.lib/author", "Romain Michon (rmichon@ccrma.stanford.edu)");
		m->declare("instrument.lib/copyright", "Romain Michon");
		m->declare("instrument.lib/version", "1.0");
		m->declare("instrument.lib/licence", "STK-4.3");
		m->declare("filter.lib/name", "Faust Filter Library");
		m->declare("filter.lib/author", "Julius O. Smith (jos at ccrma.stanford.edu)");
		m->declare("filter.lib/copyright", "Julius O. Smith III");
		m->declare("filter.lib/version", "1.29");
		m->declare("filter.lib/license", "STK-4.3");
		m->declare("filter.lib/reference", "https://ccrma.stanford.edu/~jos/filters/");
		m->declare("effect.lib/name", "Faust Audio Effect Library");
		m->declare("effect.lib/author", "Julius O. Smith (jos at ccrma.stanford.edu)");
		m->declare("effect.lib/copyright", "Julius O. Smith III");
		m->declare("effect.lib/version", "1.33");
		m->declare("effect.lib/license", "STK-4.3");
	}

	virtual int getNumInputs() 	{ return 0; }
	virtual int getNumOutputs() 	{ return 2; }
	static void classInit(int samplingFreq) {
		SIG0 sig0;
		sig0.init(samplingFreq);
		sig0.fill(65536,ftbl0);
	}
	virtual void instanceInit(int samplingFreq) {
		fSamplingFreq = samplingFreq;
		fslider0 = 2.2e+02f;
		for (int i=0; i<2; i++) fRec4[i] = 0;
		fentry0 = 0.0f;
		fentry1 = 4.4e+02f;
		iConst0 = min(192000, max(1, fSamplingFreq));
		fConst1 = (1.0f / float(iConst0));
		for (int i=0; i<2; i++) fRec3[i] = 0;
		fbutton0 = 0.0;
		for (int i=0; i<2; i++) fRec7[i] = 0;
		for (int i=0; i<2; i++) iRec5[i] = 0;
		fslider1 = 0.01f;
		fslider2 = 0.1f;
		for (int i=0; i<2; i++) fRec6[i] = 0;
		fslider3 = 0.0f;
		for (int i=0; i<2; i++) fRec8[i] = 0;
		fslider4 = 0.5f;
		for (int i=0; i<2; i++) fVec0[i] = 0;
		for (int i=0; i<2; i++) fRec14[i] = 0;
		for (int i=0; i<2; i++) fRec13[i] = 0;
		for (int i=0; i<2; i++) fRec12[i] = 0;
		for (int i=0; i<2; i++) fRec11[i] = 0;
		for (int i=0; i<2; i++) fRec10[i] = 0;
		for (int i=0; i<2; i++) fRec9[i] = 0;
		for (int i=0; i<2; i++) fRec20[i] = 0;
		for (int i=0; i<2; i++) fRec19[i] = 0;
		for (int i=0; i<2; i++) fRec18[i] = 0;
		for (int i=0; i<2; i++) fRec17[i] = 0;
		for (int i=0; i<2; i++) fRec16[i] = 0;
		for (int i=0; i<2; i++) fRec15[i] = 0;
		for (int i=0; i<2; i++) fVec1[i] = 0;
		IOTA = 0;
		for (int i=0; i<4096; i++) fVec2[i] = 0;
		fslider5 = 6.0f;
		for (int i=0; i<2; i++) fRec21[i] = 0;
		fslider6 = 0.1f;
		for (int i=0; i<2; i++) iRec22[i] = 0;
		fslider7 = 0.05f;
		for (int i=0; i<2; i++) iRec23[i] = 0;
		fslider8 = 1.0f;
		fslider9 = 0.05f;
		for (int i=0; i<2; i++) fRec24[i] = 0;
		fslider10 = 0.3f;
		for (int i=0; i<8192; i++) fRec0[i] = 0;
		fslider11 = 0.6f;
		fentry2 = 1.0f;
		for (int i=0; i<4096; i++) fVec3[i] = 0;
		fslider12 = 0.5f;
		fConst2 = (0.5f * iConst0);
	}
	virtual void init(int samplingFreq) {
		classInit(samplingFreq);
		instanceInit(samplingFreq);
	}
	virtual void buildUserInterface(UI* interface) {
		interface->openVerticalBox("saxophony");
		interface->openHorizontalBox("Basic_Parameters");
		interface->declare(&fentry1, "1", "");
		interface->declare(&fentry1, "tooltip", "Tone frequency");
		interface->declare(&fentry1, "unit", "Hz");
		interface->addNumEntry("freq", &fentry1, 4.4e+02f, 2e+01f, 2e+04f, 1.0f);
		interface->declare(&fentry2, "1", "");
		interface->declare(&fentry2, "tooltip", "Gain (value between 0 and 1)");
		interface->addNumEntry("gain", &fentry2, 1.0f, 0.0f, 1.0f, 0.01f);
		interface->declare(&fbutton0, "1", "");
		interface->declare(&fbutton0, "tooltip", "noteOn = 1, noteOff = 0");
		interface->addButton("gate", &fbutton0);
		interface->closeBox();
		interface->openHorizontalBox("Envelopes_and_Vibrato");
		interface->openVerticalBox("Envelope_Parameters");
		interface->declare(&fslider9, "5", "");
		interface->declare(&fslider9, "tooltip", "Envelope attack duration");
		interface->declare(&fslider9, "unit", "s");
		interface->addHorizontalSlider("Envelope_Attack", &fslider9, 0.05f, 0.0f, 2.0f, 0.01f);
		interface->declare(&fslider1, "5", "");
		interface->declare(&fslider1, "tooltip", "Envelope release duration");
		interface->declare(&fslider1, "unit", "s");
		interface->addHorizontalSlider("Envelope_Release", &fslider1, 0.01f, 0.0f, 2.0f, 0.01f);
		interface->closeBox();
		interface->openVerticalBox("Vibrato_Parameters");
		interface->declare(&fslider5, "4", "");
		interface->declare(&fslider5, "unit", "Hz");
		interface->addHorizontalSlider("Vibrato_Freq", &fslider5, 6.0f, 1.0f, 15.0f, 0.1f);
		interface->declare(&fslider6, "4", "");
		interface->declare(&fslider6, "tooltip", "A value between 0 and 1");
		interface->addHorizontalSlider("Vibrato_Gain", &fslider6, 0.1f, 0.0f, 1.0f, 0.01f);
		interface->closeBox();
		interface->closeBox();
		interface->openHorizontalBox("Physical_and_Nonlinearity");
		interface->openVerticalBox("Nonlinear_Filter_Parameters");
		interface->declare(&fslider0, "3", "");
		interface->declare(&fslider0, "tooltip", "Frequency of the sine wave for the modulation of theta (works if Modulation Type=3)");
		interface->declare(&fslider0, "unit", "Hz");
		interface->addHorizontalSlider("Modulation_Frequency", &fslider0, 2.2e+02f, 2e+01f, 1e+03f, 0.1f);
		interface->declare(&fentry0, "3", "");
		interface->declare(&fentry0, "tooltip", "0=theta is modulated by the incoming signal; 1=theta is modulated by the averaged incoming signal; 2=theta is modulated by the squared incoming signal; 3=theta is modulated by a sine wave of frequency freqMod; 4=theta is modulated by a sine wave of frequency freq;");
		interface->addNumEntry("Modulation_Type", &fentry0, 0.0f, 0.0f, 4.0f, 1.0f);
		interface->declare(&fslider3, "3", "");
		interface->declare(&fslider3, "tooltip", "Nonlinearity factor (value between 0 and 1)");
		interface->addHorizontalSlider("Nonlinearity", &fslider3, 0.0f, 0.0f, 1.0f, 0.01f);
		interface->declare(&fslider2, "3", "");
		interface->declare(&fslider2, "Attack duration of the nonlinearity", "");
		interface->declare(&fslider2, "unit", "s");
		interface->addHorizontalSlider("Nonlinearity_Attack", &fslider2, 0.1f, 0.0f, 2.0f, 0.01f);
		interface->closeBox();
		interface->openVerticalBox("Physical_Parameters");
		interface->declare(&fslider4, "2", "");
		interface->declare(&fslider4, "tooltip", "A value between 0 and 1");
		interface->addHorizontalSlider("Blow_Position", &fslider4, 0.5f, 0.0f, 1.0f, 0.01f);
		interface->addHorizontalSlider("Noise_Gain", &fslider7, 0.05f, 0.0f, 1.0f, 0.01f);
		interface->declare(&fslider8, "2", "");
		interface->declare(&fslider8, "tooltip", "Breath pressure (a value between 0 and 1)");
		interface->addHorizontalSlider("Pressure", &fslider8, 1.0f, 0.0f, 1.0f, 0.01f);
		interface->declare(&fslider10, "2", "");
		interface->declare(&fslider10, "tooltip", "A value between 0 and 1");
		interface->addHorizontalSlider("Reed_Stiffness", &fslider10, 0.3f, 0.0f, 1.0f, 0.01f);
		interface->closeBox();
		interface->closeBox();
		interface->openVerticalBox("Spat");
		interface->addHorizontalSlider("pan angle", &fslider11, 0.6f, 0.0f, 1.0f, 0.01f);
		interface->addHorizontalSlider("spatial width", &fslider12, 0.5f, 0.0f, 1.0f, 0.01f);
		interface->closeBox();
		interface->closeBox();
	}
	virtual void compute (int count, FAUSTFLOAT** input, FAUSTFLOAT** output) {
		float 	fSlow0 = (0.0010000000000000009f * fslider0);
		float 	fSlow1 = fentry0;
		int 	iSlow2 = (fSlow1 != 4);
		float 	fSlow3 = fentry1;
		float 	fSlow4 = (fSlow3 * (fSlow1 == 4));
		float 	fSlow5 = (0.0010000000000000009f * fbutton0);
		float 	fSlow6 = fslider1;
		float 	fSlow7 = (1 - (1.0f / powf(1e+05f,(1.0f / ((fSlow6 == 0.0f) + (iConst0 * fSlow6))))));
		float 	fSlow8 = fslider2;
		float 	fSlow9 = (1.0f / ((fSlow8 == 0.0f) + (iConst0 * fSlow8)));
		float 	fSlow10 = (0.0010000000000000009f * fslider3);
		float 	fSlow11 = fslider4;
		float 	fSlow12 = ((float(iConst0) / fSlow3) - 3);
		float 	fSlow13 = (fSlow12 * (1 - fSlow11));
		int 	iSlow14 = int(fSlow13);
		int 	iSlow15 = int((1 + int((iSlow14 & 4095))));
		int 	iSlow16 = (1 + iSlow14);
		float 	fSlow17 = (iSlow16 - fSlow13);
		int 	iSlow18 = int((1 + int((int(iSlow16) & 4095))));
		float 	fSlow19 = (fSlow13 - iSlow14);
		int 	iSlow20 = (fSlow1 >= 3);
		float 	fSlow21 = (3.141592653589793f * (fSlow1 == 2));
		float 	fSlow22 = (3.141592653589793f * (fSlow1 == 0));
		float 	fSlow23 = (1.5707963267948966f * (fSlow1 == 1));
		int 	iSlow24 = (fSlow1 < 3);
		float 	fSlow25 = (fConst1 * fslider5);
		float 	fSlow26 = fslider6;
		float 	fSlow27 = (4.656612875245797e-10f * fslider7);
		float 	fSlow28 = fslider8;
		float 	fSlow29 = (fSlow6 * fSlow28);
		float 	fSlow30 = (1 - (1.0f / powf(1e+05f,(1.0f / ((fSlow29 == 0.0f) + (iConst0 * fSlow29))))));
		float 	fSlow31 = (fslider9 * fSlow28);
		float 	fSlow32 = (1.0f / ((fSlow31 == 0.0f) + (iConst0 * fSlow31)));
		float 	fSlow33 = (0.55f + (0.3f * fSlow28));
		float 	fSlow34 = (fSlow12 * fSlow11);
		float 	fSlow35 = (1 + fSlow34);
		int 	iSlow36 = int(fSlow35);
		int 	iSlow37 = int((iSlow36 & 4095));
		float 	fSlow38 = (iSlow36 - fSlow34);
		int 	iSlow39 = int((int((1 + iSlow36)) & 4095));
		float 	fSlow40 = (fSlow35 - iSlow36);
		float 	fSlow41 = (0.1f + (0.4f * fslider10));
		float 	fSlow42 = fslider11;
		float 	fSlow43 = fentry2;
		float 	fSlow44 = (fSlow43 * (1.0f - fSlow42));
		int 	iSlow45 = int((int((fConst2 * (fslider12 / fSlow3))) & 4095));
		FAUSTFLOAT* output0 = output[0];
		FAUSTFLOAT* output1 = output[1];
		for (int i=0; i<count; i++) {
			fRec4[0] = (fSlow0 + (0.999f * fRec4[1]));
			float fTemp0 = ((fConst1 * (fSlow4 + (iSlow2 * fRec4[0]))) + fRec3[1]);
			fRec3[0] = (fTemp0 - floorf(fTemp0));
			fRec7[0] = (fSlow5 + (0.999f * fRec7[1]));
			int iTemp1 = (fRec7[0] > 0);
			iRec5[0] = (iTemp1 & (iRec5[1] | (fRec6[1] >= 1)));
			int iTemp2 = (fRec7[0] <= 0);
			int iTemp3 = (iTemp2 & (fRec6[1] > 0));
			fRec6[0] = (((iTemp3 == 0) | (fRec6[1] >= 1e-06f)) * ((fSlow9 * (((iRec5[1] == 0) & iTemp1) & (fRec6[1] < 1))) + (fRec6[1] * (1 - (fSlow7 * iTemp3)))));
			fRec8[0] = (fSlow10 + (0.999f * fRec8[1]));
			float fTemp4 = (fRec8[0] * fRec6[0]);
			float fTemp5 = (3.141592653589793f * (fTemp4 * ftbl0[int((65536.0f * fRec3[0]))]));
			float fTemp6 = sinf(fTemp5);
			float fTemp7 = ((fSlow19 * fRec0[(IOTA-iSlow18)&8191]) + (fSlow17 * fRec0[(IOTA-iSlow15)&8191]));
			fVec0[0] = fTemp7;
			float fTemp8 = (0 - fTemp6);
			float fTemp9 = cosf(fTemp5);
			float fTemp10 = ((fVec0[0] * fTemp9) + (fTemp8 * fRec9[1]));
			float fTemp11 = ((fTemp9 * fTemp10) + (fTemp8 * fRec10[1]));
			float fTemp12 = ((fTemp9 * fTemp11) + (fTemp8 * fRec11[1]));
			float fTemp13 = ((fTemp9 * fTemp12) + (fTemp8 * fRec12[1]));
			float fTemp14 = ((fTemp9 * fTemp13) + (fTemp8 * fRec13[1]));
			fRec14[0] = ((fTemp9 * fTemp14) + (fTemp8 * fRec14[1]));
			fRec13[0] = ((fTemp9 * fRec14[1]) + (fTemp6 * fTemp14));
			fRec12[0] = ((fTemp9 * fRec13[1]) + (fTemp6 * fTemp13));
			fRec11[0] = ((fTemp9 * fRec12[1]) + (fTemp6 * fTemp12));
			fRec10[0] = ((fTemp9 * fRec11[1]) + (fTemp6 * fTemp11));
			fRec9[0] = ((fTemp9 * fRec10[1]) + (fTemp6 * fTemp10));
			float fTemp15 = (fTemp4 * (((fSlow23 * (fVec0[0] + fVec0[1])) + (fSlow22 * fVec0[0])) + (fSlow21 * faustpower<2>(fVec0[0]))));
			float fTemp16 = sinf(fTemp15);
			float fTemp17 = (0 - fTemp16);
			float fTemp18 = cosf(fTemp15);
			float fTemp19 = ((fVec0[0] * fTemp18) + (fTemp17 * fRec15[1]));
			float fTemp20 = ((fTemp18 * fTemp19) + (fTemp17 * fRec16[1]));
			float fTemp21 = ((fTemp18 * fTemp20) + (fTemp17 * fRec17[1]));
			float fTemp22 = ((fTemp18 * fTemp21) + (fTemp17 * fRec18[1]));
			float fTemp23 = ((fTemp18 * fTemp22) + (fTemp17 * fRec19[1]));
			fRec20[0] = ((fTemp18 * fTemp23) + (fTemp17 * fRec20[1]));
			fRec19[0] = ((fTemp18 * fRec20[1]) + (fTemp16 * fTemp23));
			fRec18[0] = ((fTemp18 * fRec19[1]) + (fTemp16 * fTemp22));
			fRec17[0] = ((fTemp18 * fRec18[1]) + (fTemp16 * fTemp21));
			fRec16[0] = ((fTemp18 * fRec17[1]) + (fTemp16 * fTemp20));
			fRec15[0] = ((fTemp18 * fRec16[1]) + (fTemp16 * fTemp19));
			float fTemp24 = (0 - (0.95f * ((iSlow24 * (((1 - fRec8[0]) * fVec0[0]) + (fRec8[0] * ((fTemp18 * fRec15[1]) + (fVec0[0] * fTemp16))))) + (iSlow20 * ((fTemp9 * fRec9[1]) + (fVec0[0] * fTemp6))))));
			fVec1[0] = fTemp24;
			float fTemp25 = (fVec1[0] + fVec1[1]);
			fVec2[IOTA&4095] = fTemp25;
			float fTemp26 = (0.5f * fVec2[IOTA&4095]);
			float fTemp27 = (fSlow25 + fRec21[1]);
			fRec21[0] = (fTemp27 - floorf(fTemp27));
			iRec22[0] = (12345 + (1103515245 * iRec22[1]));
			iRec23[0] = (iTemp1 & (iRec23[1] | (fRec24[1] >= 1)));
			int iTemp28 = (iTemp2 & (fRec24[1] > 0));
			fRec24[0] = (((iTemp28 == 0) | (fRec24[1] >= 1e-06f)) * ((fSlow32 * (((iRec23[1] == 0) & iTemp1) & (fRec24[1] < 1))) + (fRec24[1] * (1 - (fSlow30 * iTemp28)))));
			float fTemp29 = (fSlow33 * ((fRec24[0] * (1 + (fSlow27 * iRec22[0]))) * (1 + (fSlow26 * ftbl0[int((65536.0f * fRec21[0]))]))));
			float fTemp30 = (0.5f * ((fSlow40 * fVec2[(IOTA-iSlow39)&4095]) + (fSlow38 * fVec2[(IOTA-iSlow37)&4095])));
			float fTemp31 = ((fTemp30 + fTemp29) - fTemp26);
			float fTemp32 = (0.7f + (fSlow41 * fTemp31));
			float fTemp33 = ((fTemp32 * (fTemp32 <= 1)) + (fTemp32 > 1));
			fRec0[IOTA&8191] = (fTemp29 - (fTemp26 + (fTemp31 * ((fTemp33 * (fTemp33 >= -1)) - (fTemp33 < -1)))));
			float 	fRec1 = (fTemp26 - fTemp30);
			output0[i] = (FAUSTFLOAT)(fSlow44 * fRec1);
			fVec3[IOTA&4095] = (fSlow43 * fRec1);
			output1[i] = (FAUSTFLOAT)(fSlow42 * fVec3[(IOTA-iSlow45)&4095]);
			// post processing
			fRec24[1] = fRec24[0];
			iRec23[1] = iRec23[0];
			iRec22[1] = iRec22[0];
			fRec21[1] = fRec21[0];
			IOTA = IOTA+1;
			fVec1[1] = fVec1[0];
			fRec15[1] = fRec15[0];
			fRec16[1] = fRec16[0];
			fRec17[1] = fRec17[0];
			fRec18[1] = fRec18[0];
			fRec19[1] = fRec19[0];
			fRec20[1] = fRec20[0];
			fRec9[1] = fRec9[0];
			fRec10[1] = fRec10[0];
			fRec11[1] = fRec11[0];
			fRec12[1] = fRec12[0];
			fRec13[1] = fRec13[0];
			fRec14[1] = fRec14[0];
			fVec0[1] = fVec0[0];
			fRec8[1] = fRec8[0];
			fRec6[1] = fRec6[0];
			iRec5[1] = iRec5[0];
			fRec7[1] = fRec7[0];
			fRec3[1] = fRec3[0];
			fRec4[1] = fRec4[0];
		}
	}
};


float 	Saxophony_dsp::ftbl0[65536];



#include "../common/nsmtracker.h"
#include "SoundPlugin.h"
#include "SoundPlugin_proc.h"

#include "Mixer_proc.h"
#include "SoundPluginRegistry_proc.h"

namespace{

class MyUI : public UI
{

 public:

  MyUI() 
    : _gate_control(NULL)
    , _freq_control(NULL)
    , _gain_control(NULL)
    , _num_effects(0)
    , _effect_tooltip("")
    , _curr_box_name(NULL)
  { }

  ~MyUI() {	}

  float *_gate_control;
  float *_freq_control;
  float *_gain_control;

  struct Controller{
    float* control_port;

    float min_value;
    float default_value;
    float max_value;

    std::string name;
    int type;

    const char *tooltip;
    const char *unit;

    Controller(float *control_port)
      : control_port(control_port)
      , min_value(0.0f)
      , default_value(0.5f)
      , max_value(1.0f)
      , name("<no name>")
      , type(EFFECT_FORMAT_FLOAT)
      , tooltip("")
      , unit("")
    {}
  };

  std::vector<Controller> _controllers;

  int get_controller_num(float *control_port){
    for(unsigned int i=0;i<_controllers.size();i++){
      if(control_port == _controllers.at(i).control_port)
        return i;
    }

    Controller controller(control_port);

    _controllers.push_back(controller);
    _num_effects++;

    return _controllers.size()-1;
  }

  bool is_instrument(){
    if(_gate_control!=NULL && _freq_control!=NULL && _gain_control!=NULL)
      return true;
    else
      return false;
  }

  // Remove gain/gate/freq sliders for instruments.
  void remove_instrument_notecontrol_effects(){
    if(is_instrument()){
      _controllers.erase(_controllers.begin() + get_controller_num(_gate_control));
      _controllers.erase(_controllers.begin() + get_controller_num(_freq_control));
      _controllers.erase(_controllers.begin() + get_controller_num(_gain_control));
      _num_effects -= 3;
    }
  }

  // We don't use passive items. (it would have been nice to have a passive effect telling when an instrument is finished playing)
  void remove_last_item(){
    _controllers.pop_back();
    _num_effects--;
  }
  

  int _num_effects;

  const char *_effect_tooltip;

  const char* _curr_box_name;

  // -- widget's layouts
  
  void openFrameBox(const char* label) {_curr_box_name = label;}
  void openTabBox(const char* label) {_curr_box_name = label;}
  void openHorizontalBox(const char* label) {_curr_box_name = label;}
  void openVerticalBox(const char* label) {_curr_box_name = label;}
  void closeBox() {_curr_box_name = NULL;}
  
  // -- active widgets

  void addEffect(const char *name, float* control_port, int type, float min_value, float default_value, float max_value){
    int effect_num = get_controller_num(control_port);

    Controller *controller = &_controllers.at(effect_num);

    if(_curr_box_name != NULL && strlen(_curr_box_name) < 10){
      controller->name = std::string(_curr_box_name) + ": " + name;
    }else{
      controller->name = name;
    }
    controller->type = type;
    controller->min_value = min_value;
    controller->default_value = default_value;
    controller->max_value = max_value;

    if(!strcmp(name,"gate"))
      _gate_control = control_port;

    if(!strcmp(name,"freq"))
      _freq_control = control_port;

    if(!strcmp(name,"gain"))
      _gain_control = control_port;
  }

  void addButton(const char* label, float* zone) {
    addEffect(label, zone, EFFECT_FORMAT_BOOL, 0, 0, 1);
  }
  void addToggleButton(const char* label, float* zone) {
    addEffect(label, zone, EFFECT_FORMAT_BOOL, 0, 0, 1);
  }
  void addCheckButton(const char* label, float* zone) {
    addEffect(label, zone, EFFECT_FORMAT_BOOL, 0, 0, 1);
  }
  void addVerticalSlider(const char* label, float* zone, float init, float min, float max, float step) {
    addEffect(label, zone, EFFECT_FORMAT_FLOAT, min, init, max);
  }
  void addHorizontalSlider(const char* label, float* zone, float init, float min, float max, float step) {
    addEffect(label, zone, EFFECT_FORMAT_FLOAT, min, init, max);
  }
  void addNumEntry(const char* label, float* zone, float init, float min, float max, float step) {
    addEffect(label, zone, EFFECT_FORMAT_FLOAT, min, init, max); // The INT effect format might not work. Need to go through the code first.
  }
  
  // -- passive widgets

  void addNumDisplay(const char* label, float* zone, int precision) {remove_last_item();}
  void addTextDisplay(const char* label, float* zone, const char* names[], float min, float max) {remove_last_item();}
  void addHorizontalBargraph(const char* label, float* zone, float min, float max) {remove_last_item();}
  void addVerticalBargraph(const char* label, float* zone, float min, float max) {remove_last_item();}
  
  // -- metadata declarations
  
  void declare(float* control_port, const char* key, const char* value) {
    if(control_port==NULL){
      if(!strcmp(key,"tooltip"))
        _effect_tooltip = value;
    } else {
      int effect_num = get_controller_num(control_port);
      Controller *controller = &_controllers.at(effect_num);
      if(!strcmp(key,"tooltip"))
        controller->tooltip = value;
      else if(!strcmp(key,"unit"))
        controller->unit = value;
    }
  }
};


#define MAX_POLYPHONY 32

struct Voice{
  struct Voice *prev;
  struct Voice *next;
  dsp *dsp_instance;
  MyUI myUI;
  int note_num;

  Voice()
    : prev(NULL)
    , next(NULL)
    , dsp_instance(NULL)
    , note_num(0)
  { }
};

struct Data{
  Voice *voices_playing; // not used by effects
  Voice *voices_not_playing; // not used by effects
  Voice voices[MAX_POLYPHONY];   // Only voices[0] is used by effects.
  Data()
    : voices_playing(NULL)
    , voices_not_playing(NULL)
  {}
};

} // end anonymous namespace

static void RT_add_voice(Voice **root, Voice *voice){
  voice->next = *root;
  if(*root!=NULL)
    (*root)->prev = voice;
  *root = voice;
  voice->prev = NULL;
}

static void RT_remove_voice(Voice **root, Voice *voice){
  if(voice->prev!=NULL)
    voice->prev->next = voice->next;
  else
    *root=voice->next;

  if(voice->next!=NULL)
    voice->next->prev = voice->prev;
}

static bool RT_is_silent(float *sound, int num_frames){
  for(int i=0;i<num_frames;i++)
    if(sound[i]>0.02f)
      return false;
  return true;
}

enum VoiceOp{
  VOICE_KEEP,
  VOICE_REMOVE
};

static VoiceOp RT_play_voice(Voice *voice, int num_frames, float **inputs, float **outputs){  
  voice->dsp_instance->compute(num_frames, inputs, outputs);
  if( *(voice->myUI._gate_control)==0.0f && RT_is_silent(outputs[0],num_frames))
    return VOICE_REMOVE;
  else
    return VOICE_KEEP;
}

static void RT_process_instrument(SoundPlugin *plugin, int64_t time, int num_frames, float **inputs, float **outputs){
  Data *data = (Data*)plugin->data;
  int num_outputs = plugin->type->num_outputs;

  for(int i=0;i<num_outputs;i++)
    memset(outputs[i],0,num_frames*sizeof(float));

  float *tempsounds[num_outputs];
  float tempdata[num_outputs][num_frames];
  for(int i=0;i<num_outputs;i++)
    tempsounds[i] = &tempdata[i][0];

  Voice *voice = data->voices_playing;
  
  while(voice!=NULL){
    Voice *next = voice->next;

    if(RT_play_voice(voice,num_frames,inputs,tempsounds)==VOICE_REMOVE){
      RT_remove_voice(&data->voices_playing, voice);
      RT_add_voice(&data->voices_not_playing, voice);
    }

    for(int ch=0;ch<num_outputs;ch++){
      float *source = tempsounds[ch];
      float *target = outputs[ch];
      for(int i=0;i<num_frames;i++)
        target[i] += source[i];
    }

    voice=next;
  }
}

static void play_note(struct SoundPlugin *plugin, int64_t time, int note_num, float volume){
  Data *data = (Data*)plugin->data;

  //printf("Playing %d\n",note_num);

  Voice *voice = data->voices_not_playing;

  if(voice==NULL){
    printf("no more free voices\n");
    return;
  }

  RT_remove_voice(&data->voices_not_playing, voice);
  RT_add_voice(&data->voices_playing, voice);

  *(voice->myUI._gate_control) = 1.0f;
  *(voice->myUI._freq_control) = midi_to_hz(note_num);
  *(voice->myUI._gain_control) = velocity2gain(volume);

  voice->note_num = note_num;
  
}

static void set_note_volume(struct SoundPlugin *plugin, int64_t time, int note_num, float volume){
  Data *data = (Data*)plugin->data;
  Voice *voice = data->voices_playing;
  //printf("Setting volume %f / %f\n",volume,velocity2gain(volume));
  while(voice!=NULL){
    if(voice->note_num==note_num)
      *(voice->myUI._gain_control) = velocity2gain(volume);
    voice=voice->next;
  }
}

static void stop_note(struct SoundPlugin *plugin, int64_t time, int note_num, float volume){
  Data *data = (Data*)plugin->data;
  Voice *voice = data->voices_playing;
  while(voice!=NULL){
    if(voice->note_num==note_num)
      *(voice->myUI._gate_control) = 0.0f;
    voice=voice->next;
  }
}

static void RT_process_effect(SoundPlugin *plugin, int64_t time, int num_frames, float **inputs, float **outputs){
  //SoundPluginType *type = plugin->type;
  Data *data = (Data*)plugin->data;

  data->voices[0].dsp_instance->compute(num_frames, inputs, outputs);
  //printf("in00: %f, in10: %f\n",inputs[0][0],inputs[1][0]);
  //printf("out00: %f, out10: %f\n",outputs[0][0],outputs[1][0]);
}

static void *create_effect_plugin_data(const SoundPluginType *plugin_type, struct SoundPlugin *plugin, float samplerate, int blocksize){
  Data *data = new Data;
  Voice *voice = &data->voices[0];
  voice->dsp_instance = new CLASSNAME;
  printf("Creating %s / %s. samplerate: %d\n",plugin_type->type_name,plugin_type->name,(int)samplerate);
  voice->dsp_instance->init(samplerate);
  voice->dsp_instance->buildUserInterface(&voice->myUI);
  return data;
}

static void *create_instrument_plugin_data(const SoundPluginType *plugin_type, struct SoundPlugin *plugin, float samplerate, int blocksize){
  Data *data = new Data;

  for(int i=0;i<MAX_POLYPHONY;i++){
    Voice *voice = &data->voices[i];
    voice->dsp_instance = new CLASSNAME;
    voice->dsp_instance->init(samplerate);
    voice->dsp_instance->buildUserInterface(&voice->myUI);
    voice->myUI.remove_instrument_notecontrol_effects();

    RT_add_voice(&data->voices_not_playing, voice);
  }


  return data;
}

static void cleanup_plugin_data(SoundPlugin *plugin){
  Data *data = (Data*)plugin->data;

  for(int i=0;i<MAX_POLYPHONY;i++){
    Voice *voice = &data->voices[i];
    if(voice->dsp_instance==NULL) // an effect
      break;
    else
      delete voice->dsp_instance;
  }

  delete data;
}

static const char *get_effect_name(const struct SoundPluginType *plugin_type, int effect_num){
  Data *data = (Data*)plugin_type->data;
  Voice *voice = &data->voices[0];
  MyUI::Controller *controller = &voice->myUI._controllers.at(effect_num);
  return controller->name.c_str();
}

static void set_effect_value(struct SoundPlugin *plugin, int64_t time, int effect_num, float value){
  Data *data = (Data*)plugin->data;

#ifdef DONT_NORMALIZE_EFFECT_VALUES
  float scaled_value = value;
#else
  MyUI::Controller *controller = &data->voices[0].myUI._controllers.at(effect_num);
  float min = controller->min_value;
  float max = controller->max_value;
  float scaled_value = scale(value,0,1,min,max);
#endif

  printf("Setting effect %d to %f. input: %f\n",effect_num,scaled_value,value);

  for(int i=0;i<MAX_POLYPHONY;i++){
    Voice *voice = &data->voices[i];
    if(voice->dsp_instance==NULL) // an effect
      break;
    MyUI::Controller *controller = &voice->myUI._controllers.at(effect_num);
    *(controller->control_port) = scaled_value;
  }
}

static float get_effect_value(struct SoundPlugin *plugin, int effect_num){
  Data *data = (Data*)plugin->data;
  Voice *voice = &data->voices[0];
  MyUI::Controller *controller = &voice->myUI._controllers.at(effect_num);

#ifdef DONT_NORMALIZE_EFFECT_VALUES
  return *(controller->control_port);
#else
  float min = controller->min_value;
  float max = controller->max_value;
  return scale(*(controller->control_port),min,max,0.0f,1.0f);
#endif
}

static void get_display_value_string(struct SoundPlugin *plugin, int effect_num, char *buffer, int buffersize){
  Data *data = (Data*)plugin->data;
  Voice *voice = &data->voices[0];
  MyUI::Controller *controller = &voice->myUI._controllers.at(effect_num);

  snprintf(buffer,buffersize-1,"%f %s",*(controller->control_port), controller->unit);
}

static const char *get_effect_description(const struct SoundPluginType *plugin_type, int effect_num){
  Data *data = (Data*)plugin_type->data;
  Voice *voice = &data->voices[0];
  MyUI::Controller *controller = &voice->myUI._controllers.at(effect_num);

  return controller->tooltip;
}

static int get_effect_num(const struct SoundPluginType *plugin_type, const char *effect_name){
  Data *data = (Data*)plugin_type->data;
  Voice *voice = &data->voices[0];
  for(unsigned int i=0;i<voice->myUI._controllers.size();i++){
    MyUI::Controller *controller = &voice->myUI._controllers.at(i);
    if(!strcmp(controller->name.c_str(),effect_name))
      return i;
  }
  RError("Couldn't find effect name \"%s\" in plugin %s/%s\n",plugin_type->type_name,plugin_type->name);
  return 0;
}

static void fill_type(SoundPluginType *type){
 type->type_name                = "Faust";
 type->note_handling_is_RT      = false;
 type->get_effect_format        = NULL;
 type->get_effect_name          = get_effect_name;
 type->effect_is_RT             = NULL;
 type->cleanup_plugin_data      = cleanup_plugin_data;

 type->play_note       = play_note;
 type->set_note_volume = set_note_volume;
 type->stop_note       = stop_note;

 type->set_effect_value         = set_effect_value;
 type->get_effect_value         = get_effect_value;
 type->get_display_value_string = get_display_value_string;
 type->get_effect_description   = get_effect_description;

 type->get_effect_num = get_effect_num;

 type->data                     = NULL;
};

static SoundPluginType faust_type = {0};

void CREATE_NAME (void){
  fill_type(&faust_type);

  Data *data = (Data*)create_effect_plugin_data(&faust_type, NULL, MIXER_get_sample_rate(), MIXER_get_buffer_size());
  faust_type.data = data;

  faust_type.name = DSP_NAME;

  faust_type.num_inputs = data->voices[0].dsp_instance->getNumInputs();
  faust_type.num_outputs = data->voices[0].dsp_instance->getNumOutputs();

  if(data->voices[0].myUI.is_instrument()){

    faust_type.is_instrument      = true;

    faust_type.RT_process         = RT_process_instrument;
    faust_type.create_plugin_data = create_instrument_plugin_data;

    data->voices[0].myUI.remove_instrument_notecontrol_effects();

  }else{

    faust_type.is_instrument      = false;

    faust_type.RT_process         = RT_process_effect;
    faust_type.create_plugin_data = create_effect_plugin_data;

    faust_type.play_note          = NULL;
    faust_type.set_note_volume    = NULL;
    faust_type.stop_note          = NULL;

  }

  faust_type.num_effects = data->voices[0].myUI._num_effects;

  PR_add_plugin_type(&faust_type);
}
